"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_typescript_1 = require("vue-typescript");
var _ = require("lodash");
var vqb = require("../");
//vqb=virsual-query-builer
var AndOr = /** @class */ (function (_super) {
    __extends(AndOr, _super);
    function AndOr() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.isAnd = true;
        _this.isNot = false;
        _this.groups = [];
        _this.rules = [];
        return _this;
    }
    AndOr.prototype.watchIsNot = function (newVal) {
        var $el = $(this.$el);
        if (newVal) {
            $el.find("#btn-not:first").linkbutton({ iconCls: "icon-checked" });
            $el.find("#btn-not:first").linkbutton('select');
        }
        else {
            $el.find("#btn-not:first").linkbutton('unselect');
            $el.find("#btn-not:first").linkbutton({ iconCls: "icon-unchecked" });
        }
    };
    AndOr.prototype.watchIsAnd = function (newVal) {
        var $el = $(this.$el);
        if (newVal) {
            $el.find("#btn-and:first").linkbutton('select');
            $el.find("#btn-or:first").linkbutton("unselect");
        }
        else {
            $el.find("#btn-and:first").linkbutton('unselect');
            $el.find("#btn-or:first").linkbutton("select");
        }
    };
    AndOr.prototype.addRule = function () {
        var id = this.generateId();
        this.rules.push(id);
    };
    AndOr.prototype.addGroup = function () {
        var id = this.generateId();
        this.groups.push(id);
    };
    AndOr.prototype.deleteSelf = function () {
        this.$emit('delete-group');
    };
    AndOr.prototype.deleteRule = function (index) {
        this.rules.splice(index, 1);
    };
    AndOr.prototype.cloneRule = function (index, _rule) {
        var rules = this.$refs.rules;
        var info = rules[index].queryFormStatus();
        var id = this.generateId();
        this.rules.push(id);
        var idx = this.rules.indexOf(id);
        this.$nextTick(function () {
            this.$refs.rules[idx].fillRuleStatus(info);
        });
    };
    AndOr.prototype.deleteGroup = function (index) {
        this.groups.splice(index, 1);
    };
    AndOr.prototype.queryFormStatus = function (clearEmpty) {
        if (clearEmpty === void 0) { clearEmpty = false; }
        var query = {};
        var rules = this.$refs.rules || [];
        var groups = this.$refs.groups || [];
        query.condition = this.isAnd ? 'AND' : 'OR';
        query.isNot = this.isNot;
        query.rules = [];
        rules.forEach(function (rule) {
            var formStatus = rule.queryFormStatus(clearEmpty);
            if (!_.isEmpty(formStatus)) {
                return query.rules.push(formStatus);
            }
        });
        groups.forEach(function (grp) {
            var formStatus = grp.queryFormStatus(clearEmpty);
            if (clearEmpty && _.isEmpty(formStatus.rules)) {
                formStatus = undefined;
            }
            if (!_.isEmpty(formStatus)) {
                query.rules.push(formStatus);
            }
        });
        return query;
    };
    AndOr.prototype.fillFormStatus = function (data) {
        var i, len;
        var group = this;
        group.rules = [];
        group.groups = [];
        if (data) {
            group.isAnd = /and/i.test(data.condition || "AND");
            if (data.isNot !== undefined) {
                group.isNot = !!data.isNot;
            }
            len = (data.rules || []).length;
            for (i = 0; i < len; i++) {
                if (data.rules[i].condition) {
                    group.groups.push(group.generateId());
                    (function (i, index) {
                        group.$nextTick(function () {
                            group.$refs.groups[index].fillFormStatus(data.rules[i]);
                        });
                    })(i, group.groups.length - 1);
                }
                else {
                    group.rules.push(group.generateId());
                    (function (i, index) {
                        group.$nextTick(function () {
                            group.$refs.rules[index].fillRuleStatus(data.rules[i]);
                        });
                    })(i, group.rules.length - 1);
                }
            }
        }
    };
    AndOr.prototype.generateId = function () {
        return 'xxxxxxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
            return v.toString(16);
        });
    };
    AndOr.prototype.ready = function () {
        var self = this;
        var $el = $(self.$el);
        $el.find("#btn-delete-self").linkbutton({
            iconCls: "icon-delete-group",
            plain: true,
            onClick: function () {
                $('.tooltip').hide();
                self.deleteSelf();
            }
        });
        $el.find("#btn-delete-self").tooltip({ content: "Delete this group" });
        $el.find("#btn-add-group").linkbutton({
            iconCls: "icon-add-group",
            text: "Group",
            plain: true,
            onClick: function () {
                self.addGroup();
            }
        });
        $el.find("#btn-add-group").tooltip({ content: "Add group" });
        $el.find("#btn-add-rule").linkbutton({
            iconCls: "icon-add-rule",
            text: "Rule",
            plain: true,
            onClick: function () {
                self.addRule();
            }
        });
        $el.find("#btn-add-rule").tooltip({ content: "Add rule" });
        $el.find("#btn-not").linkbutton({
            iconCls: "icon-unchecked",
            text: "Not",
            plain: false,
            outline: true,
            toggle: true,
            selected: self.isNot,
            onClick: function () {
                self.isNot = $(this).hasClass("l-btn-selected");
            }
        });
        $el.find("#btn-and").linkbutton({
            text: "&nbsp;And&nbsp;",
            plain: false,
            toggle: true,
            selected: self.isAnd,
            style: "background-color:#00bbee",
            //group:"g1",
            onClick: function () {
                self.isAnd = $(this).hasClass("l-btn-selected");
            }
        });
        $el.find("#btn-or").linkbutton({
            text: "&nbsp;Or&nbsp;",
            plain: false,
            outline: true,
            toggle: true,
            selected: !self.isAnd,
            //group:"g1",
            onClick: function () {
                self.isAnd = !$(this).hasClass("l-btn-selected");
            }
        });
        //$.parser.parse($el.find(".easyui-panel"));
        self.$nextTick(function () {
            if (_.isEmpty(self.rules))
                self.addRule();
        });
    };
    AndOr.prototype.getMongoQuery = function (_a) {
        var fluent = _a.fluent;
        var self = this;
        var clearEmpty = true;
        var grp = self.queryFormStatus(clearEmpty);
        if (fluent) {
            return vqb.getFluentMongoQueryString(grp);
        }
        else {
            return vqb.getMongoQueryAsString(grp);
        }
    };
    __decorate([
        vue_typescript_1.Watch("isNot")
    ], AndOr.prototype, "watchIsNot", null);
    __decorate([
        vue_typescript_1.Watch("isAnd")
    ], AndOr.prototype, "watchIsAnd", null);
    AndOr = __decorate([
        vue_typescript_1.VueComponent("vqb-and-or", {
            template: "<div class=\"and-or-template col-xs-12\" :class=\"isFirst ? 'and-or-first' : '' \">\n    <div class=\"form-group and-or-top col-xs-12\">\n      <div class=\"col-xs-5\" style=\"padding: 0\">\n\n        <div id=\"btn-not\"></div>\n\n        <div id=\"btn-and\" class=\"btn-radius\"></div>\n        <div id=\"btn-or\" class=\"btn-radius\"></div>\n\n        <!-- <button class=\"btn btn-xs btn-purple-outline btn-radius\"\n                :class=\" isAnd ? 'btn-purple-outline-focus' : '' \" @click.prevent=\"clickAnd\">\n          &nbsp;And&nbsp;\n        </button>\n        <button class=\"btn btn-xs btn-purple-outline btn-radius\"\n                :class=\" !isAnd ? 'btn-purple-outline-focus' : '' \" @click.prevent=\"clickOr\">\n          &nbsp;Or&nbsp;\n        </button> -->\n      </div>\n\n      <div class=\"col-xs-7 btn-and-or\">\n        <div v-if=\"!isFirst\" id=\"btn-delete-self\" class=\"pull-right\"></div>\n        <div id=\"btn-add-group\" class=\"pull-right\"></div>\n        <div id=\"btn-add-rule\" class=\"pull-right\"></div>\n      </div>\n\n    </div>\n\n\n    <vqb-rule\n      v-for=\"(index, rule) in rules\" v-ref:rules\n      :fields=\"fields\" :key=\"rule\" @delete-rule=\"deleteRule(index)\" @clone-rule=\"cloneRule(index,rule)\">\n    </vqb-rule>\n\n    <vqb-and-or\n      class=\"and-or-offset col-xs-11\"\n      v-for=\"(group, index) in groups\" v-ref:groups\n      :fields=\"fields\" :key=\"group\" @delete-group=\"deleteGroup(index)\">\n    </vqb-and-or>\n\n  </div>",
            props: {
                fields: {
                    type: Array,
                    required: true
                },
                isFirst: {
                    type: Boolean,
                    default: false
                }
            },
        })
    ], AndOr);
    return AndOr;
}(Vue));
exports.AndOr = AndOr;
//# sourceMappingURL=AndOr.js.map