"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_typescript_1 = require("vue-typescript");
var _ = require("lodash");
var vqb = require("../");
var FieldSelector = /** @class */ (function (_super) {
    __extends(FieldSelector, _super);
    function FieldSelector() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.options = {
            fields: [],
            comboOpts: {},
            includeBtnText: "",
            excludeBtnText: "",
            includeIconCls: "",
            excludeIconCls: ""
        };
        return _this;
    }
    FieldSelector.prototype.destroyed = function () {
    };
    FieldSelector.prototype.get$Fields = function () {
        var self = this;
        var $el = $(self.$el);
        return $el.find("#cc-fields");
    };
    FieldSelector.prototype.getSelStartAndEnd = function () {
        var self = this;
        var $input = self.get$Fields().combo("textbox");
        ;
        var val = $input.val();
        var selStart = $input.prop("selectionStart");
        var beforePart = val.slice(0, selStart);
        var startIdx = beforePart.lastIndexOf(",") + 1;
        //let startPart=beforePart.slice(startIdx+1);
        var afterPart = val.slice(selStart);
        var endIdx = afterPart.indexOf(",");
        if (endIdx === -1) {
            endIdx = undefined;
        }
        else {
            endIdx = selStart + endIdx;
        }
        return {
            start: startIdx,
            end: endIdx
        };
    };
    FieldSelector.prototype.getText = function () {
        return this.get$Fields().combo("getText");
    };
    FieldSelector.prototype.setText = function (value) {
        this.vmPanel.fieldFilter = "";
        this.get$Fields().combo("setText", value);
        this.get$Fields().combo("setValue", value);
    };
    FieldSelector.prototype.ready = function () {
        var self = this;
        var $el = $(self.$el);
        var $fields = self.get$Fields();
        $fields.combo(__assign({}, vqb.defaultEzInputOpt, { labelPosition: 'left', labelWidth: 70, panelMinWidth: 400, keyHandler: {
                up: function (e) {
                    if (!$fields.combobox('panel').is(':visible')) {
                        return;
                    }
                    self.vmPanel.selectRowGrid(true);
                    e.preventDefault();
                    return false;
                },
                down: function (e) {
                    if (!$fields.combobox('panel').is(':visible')) {
                        $fields.combobox('showPanel');
                    }
                    self.vmPanel.selectRowGrid();
                    e.preventDefault();
                },
                left: function (e) { },
                right: function (e) { },
                enter: _.debounce(function (e) {
                    var enterPress = true;
                    if (e.shiftKey) {
                        self.vmPanel.excludeFields(enterPress);
                    }
                    else {
                        self.vmPanel.includeFields(enterPress);
                    }
                    self.vmPanel.hidePanel();
                }, 100),
                query: function (q, e) { }
            } }, self.options.comboOpts));
        $fields.combo("textbox").bind("input", _.debounce(function () {
            var $input = $(this);
            var fieldFilter = (function () {
                var val = $input.val();
                var _a = self.getSelStartAndEnd(), start = _a.start, end = _a.end;
                var rst = val.slice(start, end).trim();
                if (rst[0] === "-") {
                    rst = rst.slice(1);
                }
                return rst;
            })();
            //console.log({ fieldFilter });
            self.vmPanel.fieldFilter = fieldFilter;
        }, 100));
        var $panel = $("<div></div>");
        $panel.appendTo($fields.combo('panel'));
        self.vmPanel = new vqb.FieldSelectorPanel({
            el: $panel[0],
            data: __assign({}, self.options)
        });
        self.vmPanel.$fieldsCombo = $fields;
        self.vmPanel.onSelectFieldsOk = function (fields, exclude) {
            if (_.isEmpty(fields))
                return;
            var fieldsStr = fields.map(function (it) {
                if (exclude)
                    return "-" + it;
                else
                    return it;
            }).join(", ");
            fieldsStr = fieldsStr + ", ";
            var $fields = self.get$Fields();
            var val = $fields.combo("getText");
            if (_.isEmpty(val)) {
                $fields.combo("setText", fieldsStr);
            }
            var _a = self.getSelStartAndEnd(), start = _a.start, end = _a.end;
            var head = val.slice(0, start);
            var tail = end > -1 ? val.slice(end + 1) : "";
            var duplicatedFields = [];
            fieldsStr = (function () {
                var rst = head + fieldsStr + tail;
                var fieldSet = {};
                rst.split(",").map(function (it) { return it.trim(); }).forEach(function (it) {
                    if (_.isEmpty(it))
                        return;
                    var negativeF = it[0] === "-";
                    var field = negativeF ? it.slice(1) : it;
                    if (fieldSet[field]) {
                        duplicatedFields.push(field);
                    }
                    fieldSet[field] = negativeF ? -1 : 1;
                });
                var includeList = [];
                var excludeList = [];
                _.keys(fieldSet).sort().forEach(function (it) {
                    if (fieldSet[it] === 1) {
                        includeList.push(it);
                    }
                    else {
                        excludeList.push("-" + it);
                    }
                });
                return _.compact(_.union(includeList, excludeList)).join(", ") + ", ";
            })();
            $fields.combo("setText", fieldsStr);
            if (!_.isEmpty(duplicatedFields)) {
                $.messager.show({
                    title: 'Warnning',
                    msg: "<span> Overwite duplicate fields: <mark><b> " + duplicatedFields.join(",") + " </b></mark><span>",
                    timeout: 3000,
                });
            }
            //$input[0].setSelectionRange(start,end);
        };
    };
    __decorate([
        vue_typescript_1.Prop
    ], FieldSelector.prototype, "options", void 0);
    FieldSelector = __decorate([
        vue_typescript_1.VueComponent("vqb-field-selector", {
            template: "<div>\n            <div id=\"cc-fields\"></div>\n    </div>"
        })
    ], FieldSelector);
    return FieldSelector;
}(Vue));
exports.FieldSelector = FieldSelector;
//# sourceMappingURL=FieldSelector.js.map