"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_typescript_1 = require("vue-typescript");
var _ = require("lodash");
//add twbs class, 兼容mb的easyui panel
var FieldSelectorPanel = /** @class */ (function (_super) {
    __extends(FieldSelectorPanel, _super);
    function FieldSelectorPanel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.fields = [];
        _this.includeBtnText = "Include";
        _this.excludeBtnText = "Exclude";
        _this.includeIconCls = "";
        _this.excludeIconCls = "";
        _this.fieldFilter = "";
        _this.$fieldsCombo = null;
        return _this;
    }
    FieldSelectorPanel.prototype.watchFieldFilter = function (newVal, oldVal) {
        var self = this;
        self.filterGrid();
    };
    FieldSelectorPanel.prototype.filterGrid = function () {
        var self = this;
        var filtedData = (function () {
            if (_.isEmpty(self.fieldFilter)) {
                return self.initData;
            }
            return self.initData.filter(function (it) {
                return (it.field || "").toLowerCase().indexOf(self.fieldFilter.toLowerCase()) > -1;
            });
        })();
        self.$grid.datagrid("clearChecked");
        self.$grid.datagrid("loadData", filtedData);
        self.$grid.datagrid("selectRow", 0);
    };
    FieldSelectorPanel.prototype.hidePanel = function () {
        var self = this;
        self.$fieldsCombo.combo("hidePanel");
    };
    FieldSelectorPanel.prototype.excludeFields = function (enterPress) {
        if (enterPress === void 0) { enterPress = false; }
        this.doIncludeExcludeFields({ exclude: true });
    };
    FieldSelectorPanel.prototype.includeFields = function (enterPress) {
        if (enterPress === void 0) { enterPress = false; }
        this.doIncludeExcludeFields({ exclude: false });
    };
    FieldSelectorPanel.prototype.selectRowGrid = function (up) {
        var t = this.$grid;
        var count = t.datagrid('getRows').length; // row count
        var selected = t.datagrid('getSelected');
        if (selected) {
            var index = t.datagrid('getRowIndex', selected);
            index = index + (up ? -1 : 1);
            if (index < 0)
                index = 0;
            if (index >= count)
                index = count - 1;
            t.datagrid('clearSelections');
            t.datagrid('selectRow', index);
        }
        else {
            t.datagrid('selectRow', (up ? count - 1 : 0));
        }
    };
    FieldSelectorPanel.prototype.ready = function () {
        var self = this;
        // console.log({
        //     includeBtnText: self.includeBtnText,
        //     excludeBtnText: self.excludeBtnText,
        //     includeIconCls: self.includeIconCls,
        //     excludeIconCls: self.excludeIconCls
        // });
        var $el = $(self.$el);
        self.$grid = $el.find("#grid-fields");
        self.initData = self.fields.map(function (it) {
            return {
                checked: false,
                field: it
            };
        });
        self.$grid.datagrid({
            idField: "field",
            striped: true,
            //            selectOnCheck:false,
            checkOnSelect: false,
            showHeader: false,
            columns: [[
                    { field: 'checked', title: 'Checked', width: "10%", checkbox: true },
                    { field: 'field', title: 'Field Name', width: "90%", },
                ]],
            data: self.initData
        });
        $el.find("#btn-include-ok").linkbutton({
            iconCls: self.includeIconCls,
            text: self.includeBtnText,
            onClick: function () {
                self.includeFields();
                self.hidePanel();
            }
        });
        $el.find("#btn-exclude-ok").linkbutton({
            iconCls: self.excludeIconCls,
            text: self.excludeBtnText,
            onClick: function () {
                self.excludeFields();
                self.hidePanel();
            }
        });
        $el.find("#btn-cancel").linkbutton({
            iconCls: 'icon-cancel',
            text: "Cancel",
            onClick: function () {
                self.hidePanel();
            }
        });
        $el.find("#btn-check-all").linkbutton({
            iconCls: 'icon-check-all',
            text: "Check All",
            onClick: function () {
                self.$grid.datagrid("checkAll");
            }
        });
        $el.find("#btn-uncheck-all").linkbutton({
            iconCls: 'icon-uncheck-all',
            text: "Uncheck All",
            onClick: function () {
                self.$grid.datagrid("clearChecked");
            }
        });
    };
    FieldSelectorPanel.prototype.doIncludeExcludeFields = function (_a) {
        var exclude = _a.exclude;
        var self = this;
        var checkedRows = self.$grid.datagrid("getChecked");
        checkedRows = checkedRows || [];
        if (_.isEmpty(checkedRows)) {
            checkedRows = self.$grid.datagrid("getSelections").slice();
        }
        checkedRows = _.compact(checkedRows);
        if (self.onSelectFieldsOk) {
            self.onSelectFieldsOk(checkedRows.map(function (it) { return it.field; }), !!exclude);
        }
        self.$grid.datagrid("clearChecked");
        self.$grid.datagrid("clearSelections");
    };
    __decorate([
        vue_typescript_1.Prop
    ], FieldSelectorPanel.prototype, "fieldFilter", void 0);
    __decorate([
        vue_typescript_1.Prop
    ], FieldSelectorPanel.prototype, "$fieldsCombo", void 0);
    __decorate([
        vue_typescript_1.Prop
    ], FieldSelectorPanel.prototype, "onSelectFieldsOk", void 0);
    __decorate([
        vue_typescript_1.Watch("fieldFilter")
    ], FieldSelectorPanel.prototype, "watchFieldFilter", null);
    FieldSelectorPanel = __decorate([
        vue_typescript_1.VueComponent("vqb-field-selector-panel", {
            template: "\n    <div class=\"twbs\">\n     <div class=\"container-fluid\">\n      <div class=\"row\"  style=\"height:165px\">\n        <div id=\"grid-fields\" style=\"height:160px\"></div>\n      </div>   \n\n      <div class=\"row\">\n        <div id=\"grid-tb\" style=\"padding:2px 5px;\">\n          <div class=\"pull-left\">\n            <div id=\"btn-check-all\"></div>\n            <div id=\"btn-uncheck-all\"></div>\n          </div>\n          <div class=\"pull-right\">\n                <div id=\"btn-include-ok\"></div>\n                <div id=\"btn-exclude-ok\"></div>\n                <div id=\"btn-cancel\"></div>\n          </div>\n        </div>\n      </div>       \n    </div>",
        })
    ], FieldSelectorPanel);
    return FieldSelectorPanel;
}(Vue));
exports.FieldSelectorPanel = FieldSelectorPanel;
//# sourceMappingURL=FieldSelectorPanel.js.map