"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_typescript_1 = require("vue-typescript");
var _ = require("lodash");
var vqb = require("../");
// export interface MongoFindParams{
//     query?: vqb.QueryGroupRst,
//     projection?:any,
//     sort?: any,
//     skip?:  number,
//     limit?: number,
// }
var VisualQueryBuilder = /** @class */ (function (_super) {
    __extends(VisualQueryBuilder, _super);
    function VisualQueryBuilder() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.isFirst = true;
        _this.fields = [];
        return _this;
    }
    Object.defineProperty(VisualQueryBuilder.prototype, "projectionOptions", {
        get: function () {
            return {
                fields: this.fields.map(function (it) { return it.name; }),
                comboOpts: {
                    prompt: 'field1, -field2     (Enter: Include Fields  Shift+Enter: Exclude Fields)',
                    label: 'Projection',
                },
                includeBtnText: "Include Fields",
                excludeBtnText: "Exclude Fields",
                includeIconCls: "icon-include-fields",
                excludeIconCls: "icon-exclude-fields",
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VisualQueryBuilder.prototype, "sortingOptions", {
        get: function () {
            return {
                fields: this.fields.map(function (it) { return it.name; }),
                comboOpts: {
                    prompt: 'field1, -field2     (Enter: ORDER BY ASC  Shift+Enter: ORDER BY DESC)',
                    label: 'Sort',
                },
                includeBtnText: "ASC",
                excludeBtnText: "DESC",
                includeIconCls: "icon-asc-fields",
                excludeIconCls: "icon-desc-fields",
            };
        },
        enumerable: true,
        configurable: true
    });
    VisualQueryBuilder.prototype.clear = function () {
        var self = this;
        var $el = $(this.$el);
        self.$refs.projection.setText("");
        self.$refs.sorting.setText("");
        $el.find("#tb-skip").textbox("setValue", "");
        $el.find("#tb-limit").textbox("setValue", "");
        self.$refs.andOr.isAnd = true;
        self.$refs.andOr.isNot = false;
        self.$refs.andOr.fillFormStatus([]);
        self.$refs.andOr.addRule();
    };
    VisualQueryBuilder.prototype.fillMongoPipeLine = function (_a) {
        var $match = _a.$match, $project = _a.$project, $sort = _a.$sort, $skip = _a.$skip, $limit = _a.$limit;
        var self = this;
        self.clear();
        var $el = $(this.$el);
        if ($skip > 0) {
            $el.find("#tb-skip").textbox("setValue", $skip.toString());
        }
        if ($limit > 0) {
            $el.find("#tb-limit").textbox("setValue", $limit.toString());
        }
        var transFields = function (fieldsObj, isSort) {
            var incFields = [];
            var decFields = [];
            _.keys(fieldsObj).forEach(function (k) {
                if (isSort) {
                    if (fieldsObj[k] === 1) {
                        incFields.push(k);
                    }
                    else {
                        if (fieldsObj[k] === -1) {
                            decFields.push(k);
                        }
                    }
                }
                else {
                    if ((fieldsObj[k] === 1) || (fieldsObj[k] === true)) {
                        incFields.push(k);
                    }
                    else {
                        if ((fieldsObj[k] === 0) || (fieldsObj[k] === false)) {
                            decFields.push(k);
                        }
                    }
                }
            });
            decFields = decFields.map(function (it) { return "-" + it; });
            return incFields.concat(decFields).join(", ") + ", ";
        };
        if (!_.isEmpty($project)) {
            self.$refs.projection.setText(transFields($project, false));
        }
        if (!_.isEmpty($sort)) {
            self.$refs.sorting.setText(transFields($sort, true));
        }
        if (!_.isEmpty($match)) {
            var rules = (function () {
                if ($match.condition && $match.rules) {
                    return $match;
                }
                return vqb.parseMongoQuery($match);
            })();
            //console.log({rules});
            self.$refs.andOr.fillFormStatus(rules);
        }
        else {
            this.$refs.andOr.addRule();
        }
    };
    VisualQueryBuilder.prototype.initComps = function () {
        this.$refs.andOr.addRule();
        //(this.$refs as any).andOr.addGroup();
    };
    VisualQueryBuilder.prototype.fetchMongoDbFindParams = function () {
        var self = this;
        var $el = $(this.$el);
        var getTextBoxInt = function (selector) {
            var str = $el.find(selector).textbox("getText").replace(/\,/g, "");
            if (_.isEmpty(str))
                return 0;
            return parseInt(str);
        };
        var rst = {
            query: self.$refs.andOr.queryFormStatus(),
            projection: self.$refs.projection.getText(),
            sort: self.$refs.sorting.getText(),
            skip: getTextBoxInt("#tb-skip"),
            limit: getTextBoxInt("#tb-limit"),
        };
        return rst;
    };
    VisualQueryBuilder.prototype.getTransFindParams = function () {
        var self = this;
        var params = self.fetchMongoDbFindParams();
        var clearEmpty = true;
        var grp = self.$refs.andOr.queryFormStatus(clearEmpty);
        var transFields = function (fields, isSort) {
            var fieldsList = _.compact((fields || "").split(",").map(function (it) { return it.trim(); }));
            var fieldObj = {};
            fieldsList.forEach(function (it) {
                if (it[0] === "-") {
                    if (isSort) {
                        fieldObj[it.slice(1)] = -1;
                    }
                    else {
                        fieldObj[it.slice(1)] = 0;
                    }
                }
                else
                    fieldObj[it] = 1;
            });
            return fieldObj;
        };
        return {
            query: grp,
            projection: transFields(params.projection, false),
            sort: transFields(params.sort, false),
            skip: params.skip,
            limit: params.limit
        };
    };
    VisualQueryBuilder.prototype.fetchMongoDBFindClause = function (fluent) {
        if (fluent === void 0) { fluent = true; }
        var params = this.getTransFindParams();
        if (fluent) {
            return vqb.codegen.getFluentMongoDBFindScript(params);
        }
        else
            return vqb.codegen.getMongoDBShellFindScript(params);
    };
    VisualQueryBuilder.prototype.ready = function () {
        var self = this;
        var $el = $(this.$el);
        $el.find("#tb-skip")
            .textbox({ label: "Skip", labelAlign: "before", labelWidth: 40, width: 100 })
            .textbox("textbox").inputmask({ alias: "integer", 'groupSeparator': ',', 'autoGroup': true });
        $el.find("#tb-limit")
            .textbox({ label: "Limit", labelAlign: "before", labelWidth: 40, width: 100 })
            .textbox("textbox").inputmask({ alias: "integer", 'groupSeparator': ',', 'autoGroup': true });
        self.$nextTick(function () {
            self.initComps();
        });
    };
    __decorate([
        vue_typescript_1.Prop
    ], VisualQueryBuilder.prototype, "isFirst", void 0);
    __decorate([
        vue_typescript_1.Prop
    ], VisualQueryBuilder.prototype, "fields", void 0);
    VisualQueryBuilder = __decorate([
        vue_typescript_1.VueComponent("vqb-builder", {
            template: "\n    <div>\n        <div class=\"row\">\n            <vqb-and-or :fields=\"fields\" :is-first=\"isFirst\" v-ref:and-or></vqb-and-or>\n        </div>\n\n        <div class=\"row and-or-template\" style=\"margin-top: -2px\">\n            <div class=\"row\" style=\"margin-top: 10px\">\n                <div class=\"col-xs-12\">\n                    <vqb-field-selector :options=projectionOptions v-ref:projection></vqb-field-selector>\n                </div>\n            </div>\n            <div class=\"row \" style=\"margin-top: 10px; margin-bottom:10px\">\n                <div class=\"col-xs-8\">\n                    <vqb-field-selector :options=sortingOptions v-ref:sorting></vqb-field-selector>\n                </div>\n                <div class=\"col-xs-2\">\n                    <div id=\"tb-skip\"></div>\n                </div>\n                <div class=\"col-xs-2\">\n                    <div id=\"tb-limit\"></div>\n                </div>\n            </div>\n        </div>\n    </div>",
        })
    ], VisualQueryBuilder);
    return VisualQueryBuilder;
}(Vue));
exports.VisualQueryBuilder = VisualQueryBuilder;
//# sourceMappingURL=QueryBuilder.js.map