"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_typescript_1 = require("vue-typescript");
var _ = require("lodash");
var assert = require("assert");
var vqb = require("../");
var mm_types_seed = 1;
var QbRule = /** @class */ (function (_super) {
    __extends(QbRule, _super);
    function QbRule() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.operator = "equal";
        _this.field = undefined;
        _this.value = undefined;
        _this.type = "String";
        _this.fields = [];
        _this.valueIsVisible = true;
        _this.typeIsVisible = true;
        return _this;
    }
    QbRule.prototype.watchField = function (newVal, oldVal) {
        var self = this;
        var $el = $(self.$el);
        $el.find("#cc-field").combobox("setValue", newVal);
        if (newVal && !self.isFilling) {
            var qryField = _.find(this.fields, function (it) { return it.name === newVal; });
            if (qryField) {
                if (self.type !== qryField.type) {
                    self.type = qryField.type;
                    self.operator = "equal";
                    self.value = "";
                }
                if (self.value === self.filledValue) {
                    self.value = "";
                }
            }
            self.createValueEditor();
        }
    };
    Object.defineProperty(QbRule.prototype, "initType", {
        get: function () {
            var _this = this;
            var fld = _.find(this.fields, function (it) { return it.name === _this.field; });
            return fld ? fld.type : "String";
        },
        enumerable: true,
        configurable: true
    });
    QbRule.prototype.opTypeVisible = function (op) {
        if (op.types && op.types.length <= 1) {
            return false;
        }
        return true;
    };
    QbRule.prototype.watchOperator = function (newVal, oldVal) {
        var self = this;
        var $el = $(self.$el);
        $el.find("#cc-op").combobox("setValue", newVal);
        var op = vqb.findRuleOp(newVal);
        assert(op);
        self.typeIsVisible = self.opTypeVisible(op);
        self.valueIsVisible = !op.noValue;
        if (self.isFilling)
            return;
        var oldOp = vqb.findRuleOp(oldVal);
        assert(oldOp);
        var oldType = self.type;
        if (!oldOp.noValue && (oldOp.perserveValue !== false) && self.valueEditor) {
            self.typeValuesMap[oldType] = self.valueEditor.getValue();
        }
        var type = (function () {
            if (_.isEmpty(op.types))
                return self.initType;
            if (!self.typeIsVisible)
                return op.types[0].fieldType;
            if (_.find(op.types, function (it) { return it.fieldType === oldType; }))
                return oldType;
            if (_.find(op.types, function (it) { return it.fieldType === self.initType; }))
                return self.initType;
            return op.types[0].fieldType;
        })();
        self.type = type;
        if (self.valueIsVisible)
            self.value = self.typeValuesMap[self.type] || "";
        //只要有改变，就重新createValueEditor
        var toCompareOp = __assign({}, oldOp, { value: op.value });
        self.refillTypesMenu();
        self.createValueEditor();
    };
    QbRule.prototype.watchType = function (newVal, oldVal) {
        var $el = $(this.$el);
        $el.find("#mb-types").menubutton({ text: newVal });
        if (!this.isFilling) {
            this.createValueEditor();
        }
    };
    QbRule.prototype.debouncedCreateValueEditor = function () {
        var self = this;
        if (this.valueEditor) {
            try {
                this.valueEditor.destroy();
            }
            catch (err) {
                console.error(err);
            }
        }
        var op = vqb.findRuleOp(self.operator);
        if (op.noValue)
            return;
        var editorType = (function () {
            var opType = _.find(op.types, function (it) { return it.fieldType === self.type; });
            if (!opType) {
                opType = op.types[0];
            }
            return opType.editorType || opType.fieldType;
        })();
        var value = (function () {
            if (op.noValue)
                return undefined;
            if (op.allowedValues) {
                if (!_.find(op.allowedValues, function (it) { return it.value === self.value; })) {
                    return op.allowedValues[0].value;
                }
            }
            return self.value;
        })();
        var possibleValues = (function () {
            if (op.allowedValues)
                return op.allowedValues;
            var qryField = _.find(self.fields, function (it) { return it.name === self.field; });
            if (!qryField)
                return [];
            return (qryField.values || []).map(function (it) { return { value: it, text: it }; });
        })();
        var params = {
            container: $(self.$el).find("#cc-value"),
            editorType: editorType,
            field: self.field,
            operator: self.operator,
            value: value,
            possibleValues: possibleValues,
            limitToList: !!op.allowedValues || undefined,
        };
        this.valueEditor = vqb.createRuleValueEditor(params);
    };
    QbRule.prototype.deleteSelf = function () {
        this.$emit('delete-rule');
    };
    QbRule.prototype.cloneSelf = function () {
        this.$emit('clone-rule');
    };
    QbRule.prototype.queryFormStatus = function (clearEmpty) {
        if (clearEmpty === void 0) { clearEmpty = false; }
        var self = this;
        if (clearEmpty && _.isEmpty(self.field))
            return;
        var value = (function () {
            if (self.valueIsVisible) {
                return self.valueEditor.getValue();
            }
            else
                return "";
        })();
        return {
            field: this.field,
            operator: this.operator,
            value: value,
            type: this.type
        };
    };
    QbRule.prototype.fillRuleStatus = function (data) {
        var _this = this;
        this.isFilling = true;
        try {
            this.field = data.field;
            this.operator = data.operator;
            this.value = (data.value || "").toString();
            this.typeValuesMap[data.type] = this.value;
            this.filledValue = this.value;
            this.type = data.type;
            this.refillTypesMenu();
            this.createValueEditor();
        }
        finally {
            _.delay(function () {
                _this.isFilling = false;
            }, 100);
        }
    };
    QbRule.prototype.destroyed = function () {
        $('#' + this.mmTypesId).menu("destroy");
    };
    QbRule.prototype.ready = function () {
        var self = this;
        var $el = $(self.$el);
        self.typeValuesMap = {};
        self.createValueEditor = _.debounce(self.debouncedCreateValueEditor, 5);
        $el.find("#cc-field").combobox(__assign({}, vqb.defaultEzInputOpt, { prompt: 'Field', data: self.fields.map(function (it) { return { value: it.name, text: it.name }; }), value: self.field, onChange: function (newVal) {
                self.field = newVal;
            } }));
        $el.find("#cc-op").combobox(__assign({}, vqb.defaultEzInputOpt, { required: true, prompt: 'Operator', data: vqb.operators.map(function (it) { return { value: it.value, text: it.text || it.value }; }), limitToList: true, value: self.operator || vqb.DEFAULT_OP, panelWidth: 150, onSelect: function (newVal, oldVal) {
                self.operator = newVal.value;
            } }));
        this.createValueEditor();
        //init types menu
        self.mmTypesId = "mm-types-" + mm_types_seed;
        mm_types_seed++;
        $('body').append("<div id='" + self.mmTypesId + "'></div>");
        $el.find("#mb-types").menubutton({
            menu: '#' + self.mmTypesId,
        });
        $('#' + self.mmTypesId).menu({
            onClick: function (item) {
                self.type = item.text;
            }
        });
        this.refillTypesMenu();
        $el.find("#btn-delete-self").linkbutton({
            iconCls: "icon-delete-rule",
            plain: true,
            onClick: function () {
                $('.tooltip').hide();
                self.deleteSelf();
            }
        });
        $el.find("#btn-delete-self").tooltip({ content: "Delete this rule" });
        $el.find("#btn-clone-self").linkbutton({
            iconCls: "icon-clone-rule",
            plain: true,
            onClick: function () {
                $('.tooltip').hide();
                self.cloneSelf();
            }
        });
        $el.find("#btn-clone-self").tooltip({ content: "Clone this rule" });
    };
    QbRule.prototype.refillTypesMenu = function () {
        var self = this;
        var $el = $(self.$el);
        var $mm = $('#' + self.mmTypesId);
        $('.menu-text', $mm) //clear menu
            .map(function (i, e) {
            return e.textContent;
        })
            .each(function (i, e) {
            $mm.menu('removeItem', $mm.menu('findItem', e).target);
        });
        //warning destroy
        var op = vqb.findRuleOp(self.operator);
        var types = (function () {
            if (_.isEmpty(op.types))
                return vqb.getDataTypeList();
            return op.types.map(function (it) { return it.fieldType; });
        })();
        types.forEach(function (it) {
            $mm.menu("appendItem", {
                text: it,
            });
        });
    };
    __decorate([
        vue_typescript_1.Prop
    ], QbRule.prototype, "fields", void 0);
    __decorate([
        vue_typescript_1.Watch("field")
    ], QbRule.prototype, "watchField", null);
    __decorate([
        vue_typescript_1.Watch("operator")
    ], QbRule.prototype, "watchOperator", null);
    __decorate([
        vue_typescript_1.Watch("type")
    ], QbRule.prototype, "watchType", null);
    QbRule = __decorate([
        vue_typescript_1.VueComponent("vqb-rule", {
            template: " <div class=\"form-group and-or-rule col-xs-12\">\n      <div class=\"col-xs-3 and-or-rule-no-padding-right\">\n        <input id=\"cc-field\">\n      </div>\n      \n      <div class=\"col-xs-2 and-or-rule-no-padding-right\">\n        <input id=\"cc-op\">\n      </div>\n\n     <div class=\"col-xs-1 and-or-rule-no-padding-right\" style=\"padding-left: 0px;\" v-show=\"typeIsVisible\">\n      <a href=\"javascript:void(0)\" id=\"mb-types\" >String</a>\n     </div>   \n\n    <div class=\"col-xs-4\" v-show=\"valueIsVisible\">\n        <div id=\"cc-value\"> </div>\n    </div>\n      <div id=\"btn-delete-self\"></div>\n      <div id=\"btn-clone-self\"></div>\n   </div>",
        })
    ], QbRule);
    return QbRule;
}(Vue));
exports.QbRule = QbRule;
//# sourceMappingURL=Rule.js.map