"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var assert = require("assert");
var moment = require("moment");
var vqb = require("../");
exports.defaultEzInputOpt = {
    width: "100%",
    prompt: 'value',
};
var EzRuleValueEditor = /** @class */ (function () {
    function EzRuleValueEditor(params) {
        this.params = params;
        this.$el = $("<div>");
        this.$el.appendTo(params.container);
        this.$elAny = this.$el;
        this.ezEditorType = "textbox";
    }
    EzRuleValueEditor.prototype.textBoxCommonOpt = function () {
        var self = this;
        return __assign({}, exports.defaultEzInputOpt, { value: this.params.value, onChange: function (newValue, oldValue) {
                self.params.onEditorValueChange && self.params.onEditorValueChange(newValue, oldValue);
            } });
    };
    EzRuleValueEditor.prototype.destroy = function () {
        this.$elAny[this.ezEditorType]("destroy");
    };
    EzRuleValueEditor.prototype.getValue = function () {
        return this.$el[this.ezEditorType]("getValue");
    };
    return EzRuleValueEditor;
}());
exports.EzRuleValueEditor = EzRuleValueEditor;
var TextRuleValueEditor = /** @class */ (function (_super) {
    __extends(TextRuleValueEditor, _super);
    function TextRuleValueEditor(params) {
        var _this = _super.call(this, params) || this;
        _this.params = params;
        _this.$el.textbox(_this.textBoxCommonOpt());
        _this.ezEditorType = "textbox";
        return _this;
    }
    return TextRuleValueEditor;
}(EzRuleValueEditor));
var StringRuleValueEditor = /** @class */ (function (_super) {
    __extends(StringRuleValueEditor, _super);
    function StringRuleValueEditor(params) {
        var _this = _super.call(this, params) || this;
        _this.params = params;
        var possibleValues = params.possibleValues, value = params.value;
        if (_.isEmpty(possibleValues)) {
            _this.$el.textbox(_this.textBoxCommonOpt());
            _this.ezEditorType = "textbox";
        }
        else {
            _this.$el.combobox(__assign({}, _this.textBoxCommonOpt(), { panelHeight: 120, limitToList: _.isUndefined(params.limitToList) ? undefined : !!params.limitToList, data: possibleValues || [] }));
            _this.ezEditorType = "combobox";
        }
        return _this;
    }
    return StringRuleValueEditor;
}(EzRuleValueEditor));
var MultiValuesEditor = /** @class */ (function (_super) {
    __extends(MultiValuesEditor, _super);
    function MultiValuesEditor(params) {
        var _this = _super.call(this, params) || this;
        _this.params = params;
        _this.$el.textbox(__assign({}, _this.textBoxCommonOpt(), { prompt: "1, 2, \"string1\", \"string2\" " }));
        _this.ezEditorType = "textbox";
        return _this;
    }
    return MultiValuesEditor;
}(EzRuleValueEditor));
var InputMaskRuleValueEditor = /** @class */ (function (_super) {
    __extends(InputMaskRuleValueEditor, _super);
    function InputMaskRuleValueEditor(params) {
        var _this = _super.call(this, params) || this;
        _this.params = params;
        var value = params.value;
        _this.$el.textbox(__assign({}, _this.textBoxCommonOpt(), { prompt: "" }));
        assert(params.inputmask);
        _this.$el.textbox("textbox").inputmask(params.inputmask);
        _this.ezEditorType = "textbox";
        return _this;
    }
    return InputMaskRuleValueEditor;
}(EzRuleValueEditor));
var BooleanRuleValueEditor = /** @class */ (function (_super) {
    __extends(BooleanRuleValueEditor, _super);
    function BooleanRuleValueEditor(params) {
        var _this = _super.call(this, params) || this;
        _this.params = params;
        var self = _this;
        var possibleValues = params.possibleValues, value = params.value;
        _this.$el.combobox(__assign({}, _this.textBoxCommonOpt(), { panelHeight: 80, limitToList: true, value: _.isEmpty(value) ? undefined : vqb.valueToBoolean(value).toString(), data: [{ value: undefined, text: "n/a" }, { value: "true", text: "true" }, { value: "false", text: "false" }] }));
        _this.ezEditorType = "combobox";
        return _this;
    }
    return BooleanRuleValueEditor;
}(EzRuleValueEditor));
function bindDateToolTip($datebox, datePattern) {
    var $textbox = $datebox.combo("textbox");
    $textbox.tooltip({
        content: "",
        onShow: function () {
            var text = $datebox.datebox("getText");
            var content = (function () {
                if (!text) {
                    return "(empty)";
                }
                ;
                var m = moment(text, datePattern);
                return "<span style=\"white-space:pre\">Local Time:\t " + m.toDate().toLocaleString() + "\n\nUTC Time:\t " + m.toDate().toISOString() + "\n\nISO 8601:\t " + m.format() + "</span>";
            })();
            $textbox.tooltip("update", content);
            $textbox.tooltip("reposition");
        }
    });
}
var DateRuleValueEditor = /** @class */ (function (_super) {
    __extends(DateRuleValueEditor, _super);
    function DateRuleValueEditor(params) {
        var _this = _super.call(this, params) || this;
        _this.params = params;
        var self = _this;
        var $datebox = self.$el;
        var possibleValues = params.possibleValues, value = params.value;
        $datebox.datebox(__assign({}, self.textBoxCommonOpt()));
        bindDateToolTip($datebox, vqb.DATE_PATTERN);
        _this.ezEditorType = "datebox";
        return _this;
        //this.$el["datebox"]("setValue", _.isUndefined(value)?"" :moment(value).format("MM/DD/YYYY"));
    }
    return DateRuleValueEditor;
}(EzRuleValueEditor));
var DateTimeRuleValueEditor = /** @class */ (function (_super) {
    __extends(DateTimeRuleValueEditor, _super);
    function DateTimeRuleValueEditor(params) {
        var _this = _super.call(this, params) || this;
        _this.params = params;
        var self = _this;
        var $datebox = self.$el;
        var possibleValues = params.possibleValues, value = params.value;
        $datebox.datetimebox(__assign({}, _this.textBoxCommonOpt()));
        bindDateToolTip($datebox, vqb.DATE_TIME_PATTERN);
        _this.ezEditorType = "datetimebox";
        return _this;
        //this.$el["datebox"]("setValue", _.isUndefined(value)?"" :moment(value).format("MM/DD/YYYY"));
    }
    return DateTimeRuleValueEditor;
}(EzRuleValueEditor));
var dataTypeDefaultEditorRegistry = {
    String: StringRuleValueEditor,
    Boolean: BooleanRuleValueEditor,
    Date: DateRuleValueEditor,
    DateTime: DateTimeRuleValueEditor,
    Number: { editor: InputMaskRuleValueEditor, inputmask: { alias: "numeric", 'groupSeparator': ',', 'autoGroup': true } },
    Int64: { editor: InputMaskRuleValueEditor, inputmask: { alias: "integer", 'groupSeparator': ',', 'autoGroup': true } },
    Decimal: { editor: InputMaskRuleValueEditor, inputmask: { alias: "decimal", 'groupSeparator': ',', 'autoGroup': true } },
    ObjectId: { editor: InputMaskRuleValueEditor, inputmask: "ObjectId(\"*{24}\")" },
    // UUID:{editor:InputMaskRuleValueEditor, inputmask:`UUID("*{8}-*{4}-*{4}-*{4}-*{12}")`},
    // LUUID:{editor:InputMaskRuleValueEditor, inputmask:`LUUID("*{8}-*{4}-*{4}-*{4}-*{12}")`},
    // MD5: {editor:InputMaskRuleValueEditor, inputmask:`md5("*{32}")`},
    // Symbol:  {editor:InputMaskRuleValueEditor, inputmask:`Symbol("*{0,1024}")`},
    // Regex: {editor:InputMaskRuleValueEditor, inputmask:"/*{0,20548}/*{0,6}"},
    Any: TextRuleValueEditor,
};
var editorRegistry = __assign({}, dataTypeDefaultEditorRegistry, { "TextSearch": TextRuleValueEditor, "BSONTypes": StringRuleValueEditor, "MultiValues": MultiValuesEditor });
function getDataTypeList() {
    return _.keys(dataTypeDefaultEditorRegistry);
}
exports.getDataTypeList = getDataTypeList;
function createRuleValueEditor(params) {
    var edtItem = editorRegistry[params.editorType];
    if (!edtItem)
        throw new Error("not support type " + params.editorType);
    var Editor = (function () {
        if (edtItem.editor)
            return edtItem.editor;
        return edtItem;
    })();
    if (edtItem.inputmask) {
        params.inputmask = edtItem.inputmask;
    }
    var editor = new Editor(params);
    if (edtItem.afterCreateEditor) {
        _.defer(function () {
            edtItem.afterCreateEditor(editor.$el);
        });
    }
    return editor;
}
exports.createRuleValueEditor = createRuleValueEditor;
//# sourceMappingURL=RuleValueEditor.js.map